'use strict';

var web = require('solid-js/web');
var solidJs = require('solid-js');

const _tmpl$ = ["<g", ">", "</g>"];
const CustomIcon = props => IconTemplate(props.src, props);
function IconTemplate(iconSrc, props) {
  const mergedProps = web.mergeProps(iconSrc.a, props);
  const [_, svgProps] = solidJs.splitProps(mergedProps, ["src"]);
  const [content, setContent] = solidJs.createSignal("");

  // When the component is mounted on the client, set the SVG content.
  solidJs.createEffect(() => setContent(iconSrc.c));

  // Cleanup the signal on component unmount.
  solidJs.onCleanup(() => {
    setContent("");
  });
  return web.ssrElement("svg", () => ({
    "stroke": iconSrc.a?.stroke,
    "color": props.color || "currentColor",
    "fill": props.color || "currentColor",
    "stroke-width": "0",
    "style": {
      ...props.style,
      overflow: "visible"
    },
    ...svgProps,
    "height": props.size || "1em",
    "width": props.size || "1em",
    "xmlns": "http://www.w3.org/2000/svg",
    "innerHTML": content()
  }), () => web.isServer && web.escape(web.ssr(web.ssr(_tmpl$, web.ssrHydrationKey(), iconSrc.c))), true);
}

exports.CustomIcon = CustomIcon;
exports.IconTemplate = IconTemplate;
